routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', 'HomeController@index' );

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::resource('/categories', 'CategoryController');

Route::resource('/types', 'TypeController');

Route::get('/preferences', 'PreferencesController@index')
		->name('preferences.index');
Route::get('/preferences/{preferences}/unit', 'PreferencesController@editUnit')
		->name('preferences.editUnit');
Route::put('/preferences/{preferences}/unit', 'PreferencesController@updateUnit')
		->name('preferences.updateUnit');

Route::resource('/widths', 'WidthsController');

Route::resource('/contacts', 'ContactsController');

// Actions Handled By Resource Controller

// Verb 		URI 					Action 		Route Name
// GET			/photos					index		photos.index
// GET			/photos/create 			create 		photos.create
// POST			/photos					store		photos.store
// GET			/photos/{photo}			show		photos.show
// GET			/photos/{photo}/edit	edit		photos.edit
// PUT/PATCH	/photos/{photo}			update		photos.update
// DELETE		/photos/{photo}			destroy		photos.destroy

app/Category.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
	//
	protected $fillable = [
		'name',
		'description'
	];

	public $timestamps = false;

	public function type()
	{
		return $this->hasOne( Type::class );
	}
	
	public function setNameAttribute( $value )
	{
		$this->attributes['name'] = ucwords( $value );
	}
}

app/Http/Controllers/CategoryController.php
<?php

namespace App\Http\Controllers;

use App\Category;
use Illuminate\Http\Request;

class CategoryController extends Controller
{

	/*
	* Style for Categories
	* Identifier: fa-tag
	*/

	/**
	 * Create a new controller instance.
	 *
	 * @return void
	 */
	public function __construct()
	{
	    $this->middleware('auth');
	}

	/**
	 * Display a listing of the resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function index()
	{
		$categories = Category::paginate(20);

		//
		return view( 'categories.index', compact('categories') );
	}

	/**
	 * Show the form for creating a new resource.
	 *
	 * @return \Illuminate\Http\Response
	 */
	public function create()
	{
		//
		return view( 'categories.new' );
	}

	/**
	 * Store a newly created resource in storage.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @return \Illuminate\Http\Response
	 */
	public function store(Request $request)
	{
		//
		$this->validate($request, [
			'name' => 'required|min:2|unique:categories,name|max:200',
			'description' => 'nullable|min:2|max:200',
		]);

		$category = new Category;

		$category->name = $request->name;
		$category->description = $request->description;

		$category->save();

		return redirect( route('categories.index') )->with('message', 'Successfully created a new Film Category.');
	}

	/**
	 * Display the specified resource.
	 *
	 * @param  \App\Category  $category
	 * @return \Illuminate\Http\Response
	 */
	public function show(Category $category)
	{
		//
	}

	/**
	 * Show the form for editing the specified resource.
	 *
	 * @param  \App\Category  $category
	 * @return \Illuminate\Http\Response
	 */
	public function edit(Category $category)
	{
		//
		return view('categories.edit', compact('category'));
	}

	/**
	 * Update the specified resource in storage.
	 *
	 * @param  \Illuminate\Http\Request  $request
	 * @param  \App\Category  $category
	 * @return \Illuminate\Http\Response
	 */
	public function update(Request $request, Category $category)
	{
		//
		$this->validate($request, [
			'name' => 'required|min:2|max:200|unique:categories,name,' . $category->id . ',id',
			'description' => 'nullable|min:2|max:200',
		]);

		$category->name = $request->name;
		$category->description = $request->description;

		$category->save();

		return redirect( route('categories.index') )->with('message', 'Successfully updated the Film Category.');
	}

	/**
	 * Remove the specified resource from storage.
	 *
	 * @param  \App\Category  $category
	 * @return \Illuminate\Http\Response
	 */
	public function destroy(Category $category)
	{
		//
		$category->delete();

		return redirect( route( 'categories.index' ) )->with('message', 'Successfully deleted Film Category.');
	}
}

resources/views/categories/edit.blade.php
@extends('layouts.app')

@section('pageTitle', 'Edit Film Category')

@section('breadcrumbs')

	<ol class="breadcrumb bg-faded">
		<li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
		<li class="breadcrumb-item"><a href="{{ route('categories.index') }}">Film Category</a></li>
		<li class="breadcrumb-item active">Edit Film Category</li>
	</ol>

@endsection

@section('content')

	<h1>Edit Film Category</h1>

	<form action="{{ route('categories.update', $category->id) }}" method="POST">
		{{ csrf_field() }}
		{{ method_field('PATCH') }}
		<fieldset class="form-group{{ $errors->has('name') ? ' has-danger' : '' }}">
			<label for="filmTypeName" class="form-control-label">Film Category Name</label>
			<input 	type="text"
					name="name"
					required="true"
					autocomplete="off"
					class="form-control"
					id="filmTypeName"
					placeholder="Ex: Etch, Frost"
				value="{{ old('name', $category->name) }}">
			<small class="form-control-feedback">
				Required. Must be unique, and at least two characters long.
			</small>
		</fieldset>
		<fieldset class="form-group{{ $errors->has('description') ? ' has-danger' : '' }}">
			<label for="filmTypeDescription" class="form-control-label">Film Category Description</label>
			<textarea 	name="description"
						autocomplete="off"
						class="form-control"
						id="filmTypeDescription"
						placeholder="Ex: Etch has an etched glass finish.">{{ old('description', $category->description) }}</textarea>
			<small class="form-control-feedback">
				Optional. Between 2 and 200 characters.
			</small>
		</fieldset>
		<fieldset class="form-group">
			<button type="submit" class="btn btn-primary btn-block">
				<span class="fa fa-disk"></span>
				Update
			</button>
			<a href="{{ route('categories.index') }}" class="btn btn-secondary btn-block">
				Cancel
			</a>
		</fieldset>
	</form>

@endsection

resources/views/categories/index.blade.php
@extends( 'layouts.app' )

@section( 'pageTitle', 'View Film Categories' )

@section('breadcrumbs')

	<ol class="breadcrumb bg-faded">
		<li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
		<li class="breadcrumb-item active">Film Categories</li>
	</ol>

@endsection

@section( 'content' )
	<h1>View Film Categories</h1>

	<p>
		<a href="{{ route('categories.create') }}" class="btn btn-info btn-block">
			<span class="fa fa-plus-square-o"></span>
			New Film Category
		</a>
	</p>

	<div class="card-columns">
		
		@foreach ($categories as $category)
		
		<div class="card">

			<div class="card-block">

				<h4 class="card-title h5">
					<a href="{{ route( 'categories.edit', $category->id ) }}">
						{{ $category->name }}
					</a>
				</h4>

				<p class="card-text text-muted text-truncate">
					<small>{{ $category->description or 'No Description Provided.' }}</small>
				</p>

			</div>

			<div class="card-footer">
				<form id="deleteForm{{ $category->id }}" action="{{ route( 'categories.destroy', $category->id ) }}" method="POST">
					{{ csrf_field() }}
					{{ method_field('DELETE') }}


					<div class="form-group">
						<a href="{{ route('categories.edit', $category->id) }}" class="btn btn-secondary btn-block btn-sm">
							<span class="fa fa-pencil"></span>
							Edit
						</a>
					</div>

					<div class="form-group">
						<button type="button" class="btn btn-outline-danger btn-block btn-sm" data-toggle="modal" data-target="#deleteConfirmModal" data-id="{{ $category->id }}">
							<span class="fa fa-trash"></span> 
							Delete
						</button>
					</div>
					
				</form>
				
			</div>
		</div>
		@endforeach
	</div>

	@if ( $categories->count() < 1 )
	<p>
		There are no Film Categories to display.
	</p>
	@endif

	<p>
		<a href="{{ route('categories.create') }}" class="btn btn-info btn-block">
			<span class="fa fa-plus-square-o"></span>
			New Film Category
		</a>
	</p>
 	
	<div class="modal fade" id="deleteConfirmModal" tabindex="-1" role="dialog" aria-labelledby="deleteConfirmModalLabel" aria-hidden="true">
		<div class="modal-dialog" role="document">
			<div class="modal-content">
				<div class="modal-header">
					<h5 class="modal-title" id="deleteConfirmModalLabel">Are you sure?</h5>
					<button type="button" class="close" data-dismiss="modal" aria-label="Close">
						<span aria-hidden="true">&times;</span>
					</button>
				</div>
				<div class="modal-body">
					<p>
						Do you really want to delete this item?
					</p>
				<div class="modal-footer">

					<button id="btnModalConfirm" type="button" class="btn btn-primary">Yes</button>
					<button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>

				</div>
			</div>
		</div>
	</div>
@endsection

@section('pageScript')
	<script type="text/javascript">
		$('#deleteConfirmModal').on('show.bs.modal', function (event) {
			var button = $(event.relatedTarget); // Button that triggered the modal
			var typeId = button.data('id'); // Extract info from data-* attributes
			// If necessary, you could initiate an AJAX request here (and then do the updating in a callback).
			// Update the modal's content. We'll use jQuery here, but you could use a data binding library or other methods instead.
			// var modal = $(this);

			$('#btnModalConfirm').click( function() {

				var modal = $('.modal');
				
				modal.modal('hide');

				$('#deleteForm' + typeId).submit();

			});

		})
	</script>
@endsection

resources/views/categories/new.blade.php
@extends('layouts.app')

@section('pageTitle', 'New Film Category')

@section('breadcrumbs')

	<ol class="breadcrumb bg-faded">
		<li class="breadcrumb-item"><a href="{{ url('/') }}">Home</a></li>
		<li class="breadcrumb-item"><a href="{{ route('categories.index') }}">Film Categories</a></li>
		<li class="breadcrumb-item active">New Film Category</li>
	</ol>

@endsection

@section('content')

	<h1>New Film Category</h1>

	<form action="{{ route('categories.store') }}" method="POST">
		{{ csrf_field() }}
		<fieldset class="form-group{{ $errors->has('name') ? ' has-danger' : '' }}">
			<label for="filmCategoryName" class="form-control-label">Film Category Name</label>
			<input 	type="text"
					name="name"
					required="true"
					autocomplete="off" 
					class="form-control"
					id="filmCategoryName"
					placeholder="Ex: Etch, Frost"
				value="{{ old('name') }}">
			<small class="form-control-feedback">
				Required. Must be unique.
			</small>
		</fieldset>
		<fieldset class="form-group{{ $errors->has('description') ? ' has-danger' : '' }}">
			<label for="filmCategoryDescription" class="form-control-label">Film Category Description</label>
			<textarea name="description" class="form-control" id="filmCategoryDescription" placeholder="Ex: Etch has an etched glass finish.">{{ old('description') }}</textarea>
			<small class="form-control-feedback">
				Optional. Between 2 and 200 characters.
			</small>
		</fieldset>
		<fieldset class="form-group">
			<button type="submit" class="btn btn-primary btn-block">
				<span class="fa fa-disk"></span>
				Save
			</button>
			<a href="{{ route('categories.index') }}" class="btn btn-secondary btn-block">
				Cancel
			</a>
		</fieldset>
	</form>

@endsection